config/routes.rb
Rails.application.routes.draw do
  resources :dairy_details
  root 'dashboard#index'
  devise_for :users
  resources :customer_payments
  resources :rate_charts
  resources :daily_collections do
    collection do
      get 'payment_register'
      get 'daily_report'
    end
  end
  resources :customers

  get 'rate_by_snf_and_fat', to: 'rate_charts#rate_by_snf_and_fat'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/dairy_detail.rb
class DairyDetail < ApplicationRecord
end

app/controllers/dairy_details_controller.rb
class DairyDetailsController < ApplicationController
  before_action :set_dairy_detail, only: [:show, :edit, :update, :destroy]

  # GET /dairy_details
  # GET /dairy_details.json
  def index
    @dairy_details = DairyDetail.all
  end

  # GET /dairy_details/1
  # GET /dairy_details/1.json
  def show
  end

  # GET /dairy_details/new
  def new
    @dairy_detail = DairyDetail.new
  end

  # GET /dairy_details/1/edit
  def edit
  end

  # POST /dairy_details
  # POST /dairy_details.json
  def create
    @dairy_detail = DairyDetail.new(dairy_detail_params)
    DairyDetail.all.first.destroy if DairyDetail.all.count > 0
    respond_to do |format|
      if @dairy_detail.save
        format.html { redirect_to @dairy_detail, notice: 'Dairy detail was successfully created.' }
        format.json { render :show, status: :created, location: @dairy_detail }
      else
        format.html { render :new }
        format.json { render json: @dairy_detail.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /dairy_details/1
  # PATCH/PUT /dairy_details/1.json
  def update
    respond_to do |format|
      if @dairy_detail.update(dairy_detail_params)
        format.html { redirect_to @dairy_detail, notice: 'Dairy detail was successfully updated.' }
        format.json { render :show, status: :ok, location: @dairy_detail }
      else
        format.html { render :edit }
        format.json { render json: @dairy_detail.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /dairy_details/1
  # DELETE /dairy_details/1.json
  def destroy
    @dairy_detail.destroy
    respond_to do |format|
      format.html { redirect_to dairy_details_url, notice: 'Dairy detail was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_dairy_detail
      @dairy_detail = DairyDetail.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def dairy_detail_params
      params.require(:dairy_detail).permit(:name, :address, :send_message)
    end
end

app/helpers/dairy_details_helper.rb
module DairyDetailsHelper
end

app/views/dairy_details/_form.html.erb
<%= form_with(model: dairy_detail, local: true) do |form| %>
  <% if dairy_detail.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(dairy_detail.errors.count, "error") %> prohibited this dairy_detail from being saved:</h2>

      <ul>
      <% dairy_detail.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group row">
    <%= form.label :name, class: 'col-sm-2 col-form-label' %>
    <div class="col-lg-10 col-md-10">
      <%= form.text_field :name, class: 'form-control' %>
    </div>
  </div>

  <div class="form-group row">
    <%= form.label :address, class: 'col-sm-2 col-form-label' %>
    <div class="col-lg-10 col-md-10">
      <%= form.text_field :address, class: 'form-control' %>
    </div>
  </div>

  <div class="form-group row">
    <%= form.label :send_message, class: 'col-sm-2 col-form-label' %>
    <div class="col-lg-10 col-md-10">
      <%= form.check_box :send_message %>
    </div>
  </div>

  <div class="actions pull-right">
    <%= form.submit 'Submit', class: 'btn btn-primary' %>
  </div>
<% end %>

app/views/dairy_details/edit.html.erb
<div class="row">
  <div class="col-3"></div>
  <div class="col-6">
    <div class="card">
      <h4 class="card-header">
        <%= link_to dairy_details_path, class: 'btn' do %>
          <i class="fa fa-arrow-left"></i>
        <% end %>
        Editing Dairy Detail

        <%= link_to 'Show', @dairy_detail %>
      </h4>
      <div class="card-body">
        <%= render 'form', dairy_detail: @dairy_detail %>
      </div>
    </div>
  </div>
  <div class="col-3"></div>
</div>

app/views/dairy_details/index.html.erb
<h1>Dairy Details
<span class="pull-right">
  <%= link_to 'New Dairy Detail', new_dairy_detail_path, class: 'btn btn-primary' %>
</span>
</h1>

<table class="table table-bordered">
  <thead>
    <tr>
      <th>Name</th>
      <th>Address</th>
      <th>Send message</th>
      <th></th>
    </tr>
  </thead>

  <tbody>
    <% @dairy_details.each do |dairy_detail| %>
      <tr>
        <td><%= dairy_detail.name %></td>
        <td><%= dairy_detail.address %></td>
        <td><%= dairy_detail.send_message %></td>
        <td>
          <div class="btn-group" role="group" aria-label="Basic example">
            <%= link_to '<i class="fa fa-eye"></i>'.html_safe,
                        dairy_detail, class: 'btn btn-primary btn-sm',
                        'data-toggle':"tooltip", 'data-placement': "top",
                        title: "Show details" %>
            <%= link_to '<i class="fa fa-edit"></i>'.html_safe,
                        edit_dairy_detail_path(dairy_detail),
                        class: 'btn btn-secondary btn-sm', 'data-toggle':"tooltip",
                        'data-placement': "top", title: "Edit Entry" %>
            <%= link_to '<i class="fa fa-trash"></i>'.html_safe,
                        dairy_detail, class: 'btn btn-danger btn-sm',
                        method: :delete, data: { confirm: 'Are you sure?' },
                        'data-toggle':"tooltip", 'data-placement': "top",
                        title: "Delete Entry" %>
          </div>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/dairy_details/new.html.erb
<div class="row">
  <div class="col-3"></div>
  <div class="col-6">
    <div class="card">
      <h4 class="card-header">
        <%= link_to dairy_details_path, class: 'btn' do %>
          <i class="fa fa-arrow-left"></i>
        <% end %>
        Add Dairy Detail
      </h4>
      <div class="card-body">
        <%= render 'form', dairy_detail: @dairy_detail %>
      </div>
    </div>
  </div>
  <div class="col-3"></div>
</div>

app/views/dairy_details/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @dairy_detail.name %>
</p>

<p>
  <strong>Address:</strong>
  <%= @dairy_detail.address %>
</p>

<p>
  <strong>Send message:</strong>
  <%= @dairy_detail.send_message %>
</p>

<%= link_to 'Edit', edit_dairy_detail_path(@dairy_detail) %> |
<%= link_to 'Back', dairy_details_path %>